;angular.module('Landers.angular')
    .directive('landersUpload', ['Flat', '$compile', 'Helpers', function(Flat, $compile, Helpers) {
        return {
            restrict : 'A',
            scope: {
                'ngModel': '=',
                'onChanged': '@',
                'onUploaded': '@',
                'onRemoved': '@',
                'onDeleted': '@'
            },
            template: '<textarea class="wp100 h100 mb10" style="display:none"></textarea>',
            link : function($scope, $ele, $attrs) {
                var $textarea = $ele.find('textarea');
                var key = $attrs['uploadKey'];
                var options = Helpers.attrItemToJson($attrs, 'uploadOptions');
                options.onChanged = function(data){
                    if (angular.isString(data)) {
                        data = angular.fromJson(data);
                    }
                    $scope.ngModel = data;
                    angular_scope_apply($scope);
                    $scope.$emit('onChanged', upload, data);
                };

                var upload = new Landers.upload($ele, $textarea, key, options);
                $scope.$watch( 'ngModel', function(new_value){
                    if (new_value) {
                        upload.setInput(new_value);
                    } else {
                        upload.clearValue();
                    }
                    upload.show();
                });
            }
        };
    }]);